#include <windows.h>
#include "CBaseDlg.h"

/* ȭ ν Base Ŭ ϱ   */
/*   Base Ŭ ڿ  ȴ.              */
CBaseDlg *pBaseDlg = NULL;

/****************************************************************************
 **                                                                        **
 **               ##  CBaseDlg ȭ ν   ##                **
 **                                                                        **
 ****************************************************************************/

BOOL CALLBACK BaseDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	switch(iMessage)
	{

		/* WM_INITDIALOG ޼ ó Լ */
	case WM_INITDIALOG:
		return pBaseDlg->OnInitDialog(hDlg);

		/* WM_MOUSEMOVE ޼ ó Լ */
	case WM_MOUSEMOVE:
		pBaseDlg->OnMouseMove(LOWORD(lParam), HIWORD(lParam));
		return TRUE;

		/* WM_COMMAND ޼ ó Լ */
	case WM_COMMAND:
		if(LOWORD(wParam) == IDCANCEL) { /* ư  üũ Ѵ. */
			if(pBaseDlg->OnClose()) {		/* ϱ OnClose Լ ȣϿ */
				EndDialog(hDlg, IDCANCEL);  /* TRUE ϸ   Ų.	*/
				return TRUE;
			}
		}

		/*  ̿ Լ ؼ OnCommand Լ ȣϿ ˸´ ޼ */
		/* ˸´ ν ǰ Ѵ. ݹ Լ ϰ  ν */
		/* ϰ Ͽ ڰ Default ó Լ Ҽ ְ Ѵ.    */
		return pBaseDlg->OnCommand(HWND(lParam), HIWORD(wParam), LOWORD(wParam));
	}

	/* FALSE Ͽ Default ȭ */
	/* ޼ ó Լ Ų.    */
	return FALSE;
}

/****************************************************************************
 **                                                                        **
 **                  ##  CBaseDlg /Ҹ   ##                 **
 **                                                                        **
 ****************************************************************************/

CBaseDlg::CBaseDlg()
{
	pBaseDlg = this;
}

CBaseDlg::~CBaseDlg()
{

}

/****************************************************************************
 **                                                                        **
 **                    ##  ܺο Ǵ Լ   ##                   **
 **                                                                        **
 ****************************************************************************/

int CBaseDlg::ShowDialogBox(HINSTANCE hInst, HWND hParent, WORD ID_DIALOG)
{
	int iResult;

	hInstance = hInst;		/* νϽ ڵ 		*/
	hWndParent = hParent;	/* θ  ڵ 	*/

	iResult = DialogBox(hInstance,					/* α׷ νϽ ڵ	*/
						MAKEINTRESOURCE(ID_DIALOG), /* ҽ ȭ ̸	*/
						hWndParent,					/* θ  ڵ		*/
						BaseDlgProc);				/* ν Լ 	*/

	/* ϰ EndDialog Լ 2° Ķ ̴. */
	return iResult;
}

/****************************************************************************
 **                                                                        **
 **                         ##  ޼ ó Լ  ##                       **
 **                                                                        **
 ****************************************************************************/

BOOL CBaseDlg::OnInitDialog(HWND hDlg)
{
	hDlgMain = hDlg; /* ȭ  ڵ  */

	return TRUE;
}

void CBaseDlg::OnMouseMove(int xPos, int yPos)
{

}

BOOL CBaseDlg::OnCommand(HWND hWndCtl, int wNotifyCode, int wID)
{
	return FALSE;
}

BOOL CBaseDlg::OnClose()
{
	return TRUE;
}