#include <windows.h>
#include "CBaseDlg.h"
#include "CSerialComm.h"			/* ø Ʈ  Ŭ					*/
#include "CStatusViewListBox.h"		/* Status View List Box Ŭ Ŭ */

#if !defined(CMainDlg_CLASS_INCLUDED)
#define CMainDlg_CLASS_INCLUDED

/* α׷ ̴  &  ġ  ü  .		*/
/*  ü _EnvSet Ե ʰ   ϴ 	*/
/* CLocationDlg  &   ޴ ü Ѱٶ	ø	*/
/* Ʈ  ִ _EnvSet Ѱ ʰ,  ü Ѱ */
/* ֱ ؼ̴. ̷ ϸ ø Ʈ   ȣ	*/
/* ̷ ִ.														*/
typedef struct {
	char szToolsPath[MAX_PATH];		/* Build  ġ ִ ġ	*/
	char szWorkingPath[MAX_PATH];	/* Build  ۾   ġ		*/
	char szEditorPath[MAX_PATH];		/*  ϴ α׷ ġ		*/
} _PathInfo;

/* α׷ ̴ (, , ø Ʈ ) */
/* ѹ ϴ ü										*/
typedef struct {
	_PathInfo	stPathInfo;			/*  &  ġ  ü  		*/
	_CommInfo	stCommInfo;			/* øƮ   ִ ü   */
} _EnvSet;

class CMainDlg : public CBaseDlg
{
public:
	CMainDlg();		/*  */
	~CMainDlg();	/* Ҹ */

private: /* ޼ ó Լ */

	/* WM_INITDIALOG ޼ ó Լ */
	BOOL OnInitDialog(HWND hDlg);

	/* WM_COMMAND ޼ ó Լ */
	BOOL OnCommand(HWND hWndCtl, int wNotifyCode, int wID);

	/* WM_CLOSE  ޼ ó Լ */
	BOOL OnClose();

private: /* WM_COMMAND ޼ ó Ǵ Լ */

	/* Source  Open ư óϴ Լ */
	void OnSourceFileOpen();

	/* Source  Edit ư óϴ Լ */
	void OnSourceFileEdit();

	/* Compile ư óϴ Լ */
	BOOL OnCompile();

	/* Link ư óϴ Լ */
	BOOL OnLink();

	/* to Hex ư óϴ Լ */
	BOOL OnToHex();

	/* Build ư óϴ Լ */
	BOOL OnBuild();

	/* Hex  Open ư óϴ Լ */
	void OnHexFileOpen();

	/* Hex  Edit ư óϴ Լ */
	void OnHexFileEdit();

	/* ø Ʈ Download ȣ  Լ */
	BOOL OnDownloadSignal();

	/* ø Ʈ Run ȣ  Լ */
	BOOL OnRunSignal();

	/* ø Ʈ Stop ȣ  Լ */
	BOOL OnStopSignal();

	/* View ASM ư óϴ Լ */
	void OnViewASM();

	/* View LST ư óϴ Լ */
	void OnViewLST();

	/* View MAP ư óϴ Լ */
	void OnViewMAP();

	/* Link Command ư óϴ Լ */
	void OnLinkCmdSetting();

	/* Hex Command ư óϴ Լ */
	void OnHexCmdSetting();

	/* Location ư óϴ Լ */
	void OnLocationSetting();

	/* Serial Port ư óϴ Լ */
	void OnSerialPortSetting();

	/* Send ư óϴ Լ */
	void OnSendMessage();

	/* Clear ư óϴ Լ */
	void OnClear();

	/* About ư óϴ Լ */
	void OnAbout();

private: /* Ŭ  Լ */

	/* α׷ ʱȭ Ű Լ */
	BOOL InitProgram();

	/* ȯ  ͸ ⺻  Ѵ. */
	void DefaultEnvSetting();

	/* ø Ʈ ʱȭ ϴ Լ */
	BOOL InitSerialPort();

	/* Status View List Box ڿ ִ߰ Լ */
	BOOL AddString(UINT nID);

	/* Intel Hex Ͽ ʵ  ǥø ãƳ Լ */
	BOOL GetFieldStartChar(HANDLE hFile);

	/* Intel Hex Ϸ  1Ʈ  . */
	BOOL GetByte(HANDLE hFile, BYTE &btDone);

	/*  Ʈ Hex  Nibble  ȯѴ. */
	BOOL ConvertHexToNibble(BYTE &btHexToNibble);

	/* Delay Լ */
	BOOL Delay(int iMicroSecs);

	/* Ȯ ó ù ڸ ִ Լ */
	BOOL GetFirstCharInExt(char *pFileName, char &cGet);

	/* ϸ Ȯڸ ٲִ Լ */
	BOOL ChangeExtension(char *pFileName, char *pNewExt);

	/* ϸ Ȯڸ ִ Լ */
	BOOL EraseExtension(char *pFileName);

	/* Bin α׷   ϴ Լ */
	BOOL RunBinWriteResult(char *pRunCommand, char *pResultPath);

	/* Ͽ ȯ  ü ͸ о̴ Լ */
	BOOL ReadEnvSet();

	/* Ͽ ȯ  ü ͸ ϴ Լ */
	BOOL WriteEnvSet();
	
	/*  θ߿  ִ ˾Ƴ Լ */
	BOOL BlankInPath(char *pPath);

	/*  ̹ ȭ Ű Լ */
	void SetStatusImage(BOOL IsOn);

private: /*   */

	/* øƮ  Ŭ  */
	CSerialComm *pSerialComm;

	/* Status View List Box Ķ Ŭ  */
	CStatusViewListBox *pStatusView;

	/* ȯ  Ͱ ִ ü   */
	_EnvSet	stEnvSet;
	
	/* ڿ ̺ ؼ ؿ ڿ   */
	char szGetString[256];

};

#endif