#include <windows.h>
#include "CChildDlg.h"

/* ȭ ν Base Ŭ ϱ   */
/*   Base Ŭ ڿ  ȴ.              */
CChildDlg *pChildDlg = NULL;

/****************************************************************************
 **                                                                        **
 **               ##  CChildDlg ȭ ν   ##                **
 **                                                                        **
 ****************************************************************************/

BOOL CALLBACK ChildDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	switch(iMessage)
	{

		/* WM_INITDIALOG ޼ ó Լ */
	case WM_INITDIALOG:
		return pChildDlg->OnInitDialog(hDlg);

		/* WM_MOUSEMOVE ޼ ó Լ */
	case WM_MOUSEMOVE:
		pChildDlg->OnMouseMove(LOWORD(lParam), HIWORD(lParam));
		return TRUE;

		/* WM_COMMAND ޼ ó Լ */
	case WM_COMMAND:
		if(LOWORD(wParam) == IDCANCEL) { /* ư  üũ Ѵ. */
			if(pChildDlg->OnClose()) {		/* ϱ OnClose Լ ȣϿ */
				EndDialog(hDlg, IDCANCEL);  /* TRUE ϸ   Ų.	*/
				return TRUE;
			}
		}

		/*  ̿ Լ ؼ OnCommand Լ ȣϿ ˸´ ޼ */
		/* ˸´ ν ǰ Ѵ. ݹ Լ ϰ  ν */
		/* ϰ Ͽ ڰ Default ó Լ Ҽ ְ Ѵ.    */
		return pChildDlg->OnCommand(HWND(lParam), HIWORD(wParam), LOWORD(wParam));
	}

	/* FALSE Ͽ Default ȭ */
	/* ޼ ó Լ Ų.    */
	return FALSE;
}

/****************************************************************************
 **                                                                        **
 **                  ##  CChildDlg /Ҹ   ##                  **
 **                                                                        **
 ****************************************************************************/

CChildDlg::CChildDlg()
{
	pChildDlg = this;
}

CChildDlg::~CChildDlg()
{

}

/****************************************************************************
 **                                                                        **
 **                    ##  ܺο Ǵ Լ   ##                   **
 **                                                                        **
 ****************************************************************************/

int CChildDlg::ShowDialogBox(HINSTANCE hInst, HWND hParent, WORD ID_DIALOG)
{
	int iResult;

	hInstance = hInst;		/* νϽ ڵ 		*/
	hWndParent = hParent;	/* θ  ڵ 	*/

	iResult = DialogBox(hInstance,					/* α׷ νϽ ڵ	*/
						MAKEINTRESOURCE(ID_DIALOG), /* ҽ ȭ ̸	*/
						hWndParent,					/* θ  ڵ		*/
						ChildDlgProc);				/* ν Լ 	*/

	/* ϰ EndDialog Լ 2° Ķ ̴. */
	return iResult;
}

/****************************************************************************
 **                                                                        **
 **                         ##  ޼ ó Լ  ##                       **
 **                                                                        **
 ****************************************************************************/

BOOL CChildDlg::OnInitDialog(HWND hDlg)
{
	hDlgMain = hDlg; /* ȭ  ڵ  */

	return TRUE;
}

void CChildDlg::OnMouseMove(int xPos, int yPos)
{

}

BOOL CChildDlg::OnCommand(HWND hWndCtl, int wNotifyCode, int wID)
{
	return FALSE;
}

BOOL CChildDlg::OnClose()
{
	return TRUE;
}