#include <windows.h>

#if !defined(CSerialComm_CLASS_INCLUDED)
#define CSerialComm_CLASS_INCLUDED

typedef struct {
	int   Port;			/* Com Port ȣ					*/
	DWORD BaudRate;		/* Com Port  ӵ				*/
	BYTE  ByteSize;		/* ѹ ϴ Ʈ/Ʈ 	*/
	BYTE  StopBits;		/* Stop bit 					*/
	BYTE  Parity;		/* иƼ Ʈ 					*/
} _CommInfo;

class CSerialComm
{
public:
	CSerialComm();  /*  */
	~CSerialComm(); /* Ҹ */

public: /* ܺο Ǵ Լ */

	/*  Com Port  */
	void SetComPort(_CommInfo &stInfo);

	/* Com Ʈ  θ ˾Ƴ Լ */
	BOOL IsComOpen();

	/* Com Port  Ű Լ */
	BOOL OpenComPort();

	/* Com Port    Լ */
	BOOL SendData(LPSTR lpByte, DWORD dwLength);

	/* Clear Data Terminal Ready Լ */
	BOOL ClearDTR();

	/* Set Data Terminal Ready Լ */
	BOOL SetDTR();

	/* Com Port Close Լ */
	BOOL CloseComPort();

private: /* Ŭ   */

	_CommInfo stCommInfo;

	HANDLE hCom;	/* Com Port Handle */

	/* Com Ʈ µǾִ Ÿ   */
	BOOL bAlreadyComOpen;
};

#endif