//Comm.cpp Rs232c ϱ  Ŭ
#include <windows.h>
#include "comm.h"

CComm::CComm( )
{
   idComDev=NULL;
   bFlowCtrl= FC_XONXOFF ;
   fConnected      = FALSE ;
}

CComm::~CComm( )
{
    DestroyComm();
}


/////////////////////////////////////////////////////////////////////////////
// CComm message handlers
//CommWatchProc()
// ϴ μ  Ÿ  ϴ
//ƾ ƾ OpenComPort Լ  ν 
//OpenComPort Լ 
DWORD CommWatchProc(LPVOID lpData)
{
   DWORD       dwEvtMask ;
   OVERLAPPED  os ;
   CComm*      npComm = (CComm*) lpData ;
   char InData[MAXBLOCK + 1];
	int        nLength ;
   //idCommDev  ڵ鿡 ƹ com Ʈ Ⱥپ 
   //  

   memset( &os, 0, sizeof( OVERLAPPED ) ) ;


   os.hEvent = CreateEvent( NULL,    // no security
                            TRUE,    // explicit reset req
                            FALSE,   // initial event reset
                            NULL ) ; // no name
   if ( os.hEvent == NULL )
   {
      MessageBox( NULL, "Failed to create event for thread!", "comm Error!",
                  MB_ICONEXCLAMATION | MB_OK ) ;
      return ( FALSE ) ;
   }

   if (!SetCommMask(npComm->idComDev, EV_RXCHAR ))
      return ( FALSE ) ;

   while (npComm->fConnected )
   {
		dwEvtMask = 0 ;

		WaitCommEvent(npComm->idComDev, &dwEvtMask, NULL );

		if ((dwEvtMask & EV_RXCHAR) == EV_RXCHAR)
		{

			do
		   {
			   memset(InData,0,80);
				if (nLength = npComm->ReadCommBlock((LPSTR) InData, MAXBLOCK ))
				{
                  npComm->SetReadData(InData);
               //̰ Ÿ ޴´.
		      	}
		   }
		   while ( nLength > 0 ) ;
		}
   }

  
   CloseHandle( os.hEvent ) ;


   return( TRUE ) ;

} 
//Ÿ ϰ Ÿ оٴ
//޼ Ѵ.
void CComm::SetReadData(LPSTR data)
{
   lstrcpy((LPSTR)abIn,(LPSTR)data);
   //ConverData
   // 쿡 WM_RECEIVEDATA޼
   //־  Ÿ Դٴ°
   //˷ش.
   SendMessage(m_hwnd,WM_RECEIVEDATA,0,0);
}
//޼  hwnd
void CComm::SetHwnd(HWND hwnd)
{
   m_hwnd=hwnd;
}
//Ʈ Ѵ.
void CComm::SetComPort(int port,DWORD rate,BYTE bytesize,BYTE stop,BYTE parity)
{
   bPort=port;
   dwBaudRate=rate;
   bByteSize=bytesize;
   bStopBits=stop;
   bParity=parity;
}
//XonOff  ϰ  
void CComm::SetXonOff(BOOL chk)
{
   fXonXoff=chk;
}
void CComm::SetDtrRts(BYTE chk)
{
   bFlowCtrl=chk;
}
//Ʈ  .
//̰ 鶧  
// SetComPort(); -> SetXonOff() ->SetDtrRts() Ѵ Ѵ.
BOOL CComm::CreateCommInfo()
{


   osWrite.Offset = 0 ;
   osWrite.OffsetHigh = 0 ;
   osRead.Offset = 0 ;
   osRead.OffsetHigh = 0 ;

//̺Ʈ â 
   osRead.hEvent = CreateEvent( NULL, TRUE, FALSE, NULL ) ; 
   if (osRead.hEvent == NULL)
   {
      return FALSE ;
   }
   osWrite.hEvent = CreateEvent( NULL,   TRUE,  FALSE,   NULL ) ;
   if (NULL == osWrite.hEvent)
   {
      CloseHandle( osRead.hEvent ) ;
      return FALSE;
   }


   return TRUE ;

} 

//com Ʈ   õѴ.
//OpenComport()
BOOL CComm::OpenComPort( )
{            
   char       szPort[ 15 ] ;
   BOOL       fRetVal ;
   COMMTIMEOUTS  CommTimeOuts ;


   if (bPort > MAXPORTS)
      lstrcpy( szPort, "\\\\.\\TELNET" ) ;
   else
      wsprintf( szPort, "COM%d", bPort ) ;

   // COMM device ȭ Ѵ.

   if ((idComDev =
      CreateFile( szPort, GENERIC_READ | GENERIC_WRITE,
                  0,                    // exclusive access
                  NULL,                 // no security attrs
                  OPEN_EXISTING,
                   FILE_ATTRIBUTE_NORMAL | 
                  FILE_FLAG_OVERLAPPED, // overlapped I/O
                  NULL )) == (HANDLE) -1 )
      return ( FALSE ) ;
   else
   {
      //Ʈ Ÿ ȯϴ  char ⺻ 
      //
      SetCommMask( idComDev, EV_RXCHAR ) ;
      SetupComm( idComDev, 4096, 4096 ) ;
      //̽ Ⱑ  𸣴ϱ  ûҸ !
      PurgeComm( idComDev, PURGE_TXABORT | PURGE_RXABORT |
                                      PURGE_TXCLEAR | PURGE_RXCLEAR ) ;

     
      CommTimeOuts.ReadIntervalTimeout = 0xFFFFFFFF ;
      CommTimeOuts.ReadTotalTimeoutMultiplier = 0 ;
      CommTimeOuts.ReadTotalTimeoutConstant = 1000 ;
      CommTimeOuts.WriteTotalTimeoutMultiplier = 0 ;
      CommTimeOuts.WriteTotalTimeoutConstant = 1000 ;
      SetCommTimeouts( idComDev, &CommTimeOuts ) ;
   }

   fRetVal = SetupConnection() ;

   if (fRetVal)// Ǿٸ fRetVal TRUE̹Ƿ
   {
      fConnected = TRUE ;//Ǿٰ 
      //ν CommWatchProc ϴϱ ߿ Ÿ Դٰ
      //ϸ   CommWatchProc Ѵ.
 //     ::AfxBeginThread((AFX_THREADPROC)CommWatchProc,(LPVOID)this);
   }
   else
   {
      fConnected = FALSE ;
      CloseHandle( idComDev) ;
   }

   return ( fRetVal ) ;

} 

//ȭϷ  Ʈ  Ʈ  Ų.
//SetupConnection  CreateComPort ־ Ѵ.
BOOL CComm::SetupConnection()
{
   BOOL       fRetVal ;
   BYTE       bSet ;
   DCB        dcb ;

   dcb.DCBlength = sizeof( DCB ) ;

   GetCommState( idComDev, &dcb ) ;//dcb ⺻ ޴´.


   //̺κ ؾ մϴ.
   dcb.BaudRate = dwBaudRate;//ۼӵ
   dcb.ByteSize = bByteSize ;//ŸƮ
   dcb.Parity = bParity;//иƼ üũ
   dcb.StopBits = bStopBits;//ư

   dcb.fOutxDsrFlow =0 ;//Dsr Flow
   dcb.fDtrControl = DTR_CONTROL_ENABLE ;//Dtr Control
   dcb.fOutxCtsFlow = 0 ;//Cts Flow
   dcb.fRtsControl = RTS_CONTROL_ENABLE ; //Ctr Control
   dcb.fInX = dcb.fOutX = 1 ; //XON/XOFF Ѱ
   dcb.XonChar = ASCII_XON ;
   dcb.XoffChar = ASCII_XOFF ;
   dcb.XonLim = 100 ;
   dcb.XoffLim = 100 ;
   dcb.fBinary = TRUE ;
   dcb.fParity = TRUE ;



   dcb.fBinary = TRUE ;
   dcb.fParity = TRUE ;

   fRetVal = SetCommState( idComDev, &dcb ) ; // Dcb 

   return ( fRetVal ) ;

} 

//Ʈ  Ÿ д´.
int CComm::ReadCommBlock(LPSTR lpszBlock, int nMaxLength )
{
	BOOL       fReadStat ;
	COMSTAT    ComStat ;
	DWORD      dwErrorFlags;
	DWORD      dwLength;

	// only try to read number of bytes in queue 
	ClearCommError( idComDev, &dwErrorFlags, &ComStat ) ;
	dwLength = min( (DWORD) nMaxLength, ComStat.cbInQue ) ;

	if (dwLength > 0)
	{
		fReadStat = ReadFile( idComDev, lpszBlock,
		                    dwLength, &dwLength, &osRead ) ;
		if (!fReadStat)
		{
         //̰  ִ°̴.
         // ReadFile  Ÿ  ȳ fReadState 
         // ڵ带 Ѵ. ̶ Ҽ  
         // Ұϴ   ش޶ ޼ ִ°
         //.
		}
   }
   
   return ( dwLength ) ;

} 
//Ʈ  Ѵ.

BOOL CComm::DestroyComm()
{


   if (fConnected)
      CloseConnection( ) ;


   CloseHandle( osRead.hEvent ) ;
   CloseHandle( osWrite.hEvent ) ;

   return ( TRUE ) ;

} 

// ݴ´.
BOOL CComm::CloseConnection()
{

   // set connected flag to FALSE

   fConnected = FALSE ;

   // disable event notification and wait for thread
   // to halt

   SetCommMask( idComDev, 0 ) ;



   EscapeCommFunction( idComDev, CLRDTR ) ;


   PurgeComm( idComDev, PURGE_TXABORT | PURGE_RXABORT |
                                   PURGE_TXCLEAR | PURGE_RXCLEAR ) ;
   CloseHandle( idComDev ) ;
   return ( TRUE ) ;

} 



BOOL CComm::WriteCommBlock( LPSTR lpByte , DWORD dwBytesToWrite)
{

	BOOL        fWriteStat ;
	DWORD       dwBytesWritten ;


	fWriteStat = WriteFile( idComDev, lpByte, dwBytesToWrite,
	                       &dwBytesWritten, &osWrite ) ;


	if (!fWriteStat) 
	{
      //Ʈ Ÿ   ̴.
      //̶  ұ װ  ̰ڴ.
      //ٽ   ͼ ϸ ȴ.
      //׷     ִٴ ϶
	}
	return ( TRUE ) ;

} 
